import { Button, Descriptions, Badge, Popconfirm, Row, Col, Form, Input, Select, Table } from 'antd';
import React from 'react';
import { initFilter, extendRule, extendInclude, extendIgnoreDataRule, setDataFieldValue, showApprove, guid, showFiles, showUsersSign, ShowPrintClose } from '../../../utils/common';
import ReactToPrint from 'react-to-print';
import { ExportToExcel } from '@woowalker/feui'
import XLSX from 'xlsx';
import { connect } from 'dva';
import moment from 'moment';
import { message } from 'antd/lib/index';
import styles from '../HI/StepForm.css';
import config from '../../../config.js';
import FormPage from '../../FormPage'
class DM032ShowPrint extends React.Component {
    constructor(props) {
        super(props);
        this.state = {
            data: null,
            btndisplay: 'none',
            isCheck: false, //是否待办 审批
            listUserSign: null
        }
    }

    componentDidMount() {
        if (this.props.data?.id)
            this.loadData(this.props.data?.id);
    }

    componentWillReceiveProps(NextProps) {
        if (NextProps.data?.id && this.props.data?.id != NextProps.data?.id) {
            this.loadData(NextProps.data?.id);
        }
    }

    onTableBtnExport() {
        let TableWrap = document.getElementById('table1');
        let Table = TableWrap.getElementsByTagName('table1')[0];
        const wb = XLSX.utils.table_to_book(Table);
        XLSX.writeFile(wb, this.props.record.Nav_Department.NAME + '.xlsx')

    }

    onClickApprove = (appVisible) => {
        const newtmpData = {
            data: { id: this.props.data.id, isShow: true, key: guid(), param: this.props.data.param, appVisible: appVisible, BtnAgreeDisplay: 'none' },
            formCode: 'PF123',
        }
        this.setState({
            tmpData: newtmpData,
        });
    }
    loadData = (id) => {
        var isCheck = (this.props.data.tableKey != undefined && this.props.data.tableKey == '1') ? true : false
        var orgId = this.props.login ? this.props.login.OrgId : '';
        let json = initFilter(orgId);
        extendRule(json, 'ID', 1, id);
        extendInclude(json, 'Nav_DeviceBase')
        extendInclude(json, 'Nav_ListDetail')
        extendInclude(json, 'Nav_ListUser.Nav_User.Nav_UserSignFiles.Nav_ImgFile.Nav_File')
        extendInclude(json, 'Nav_Files.Nav_ImgFile.Nav_File');
        extendIgnoreDataRule(json)
        this.props.dispatch({
            type: 'app/getDataByPost',
            payload: json,
            url: 'DM/DeviceCheck/Get',
            onComplete: (ret) => {
                if (ret) {
                    var listUserSign = []
                    if (ret.Nav_ListUser != null && ret.Nav_ListUser.length > 0) {
                        for (let i = 0; i < ret.Nav_ListUser.length; i++) {
                            if (ret.Nav_ListUser[i].ISCHECK == true) {
                                listUserSign.push(ret.Nav_ListUser[i])
                            }
                        }
                    }
                    this.setState({
                        data: ret,
                        isCheck: isCheck,
                        listUserSign: listUserSign
                    })
                }
            }
        });
    }
    sign = () => {
        let json = initFilter(this.props.login.OrgId, this.props.data.id, null, null, null, this.props.data.TaskID);
        extendRule(json, 'ID', 1, this.props.data.id);
        extendRule(json, 'Parameter1', 1, this.props.data.TaskID)
        extendIgnoreDataRule(json)
        this.props.dispatch({
            type: 'app/getDataByPost',
            payload: json,
            url: 'DM/DMDeviceCheck/Check',
            onComplete: (ret) => {
                ShowPrintClose(this.props)
            }
        });
    }
    render() {
        const { data, isCheck, listUserSign } = this.state;
        const enums = this.props.data.enums ? this.props.data.enums : this.props.app.enums;
        return <div>
            <div style={{ padding: '10px' }}>
                <table>
                    <tr>
                        {/* <td><Button onClick={() => this.onClickApprove(true)} style={{ marginRight: '8px' }} icon='export'>审批详情</Button></td> */}
                        <td><ReactToPrint trigger={() => <Button type={'default'} icon={'printer'} >打印</Button>} content={() => this.componentRef} pageStyle={"#tableId" + this.props.data.id + " { padding:0 40px;} img{width :120px}"} /></td>
                        <td><ExportToExcel fileName='设备设施巡检' tableId={'tableId' + this.props.data.id} /></td>
                        {isCheck ? <td><Button type={'primary'} icon={'check'} onClick={() => this.sign()} >确认</Button>  </td> : null}
                    </tr>
                </table>
            </div>
            <FormPage {...this.state.tmpData} />
            <div ref={el => (this.componentRef = el)} style={{ padding: '20px', paddingTop: '20px' }} id={'tableId' + this.props.data.id}>
                <h1 className={styles.showPrintHead}>设备设施巡检</h1>
                {
                    data ? <div style={{ width: '95%' }}>
                        <Descriptions title='' size='middle' bordered>
                            <Descriptions.Item label="巡检时间" >{data.RECORD_DATE}</Descriptions.Item>
                            <Descriptions.Item label="班次">{data.TEAM_NAME}</Descriptions.Item>
                            <Descriptions.Item label="设备设施">{data.Nav_DeviceBase.NAME}</Descriptions.Item>
                            <Descriptions.Item label="规格/型号">{data.SPEC}</Descriptions.Item>
                            <Descriptions.Item label="设备编号">{data.MACHINE_CODE}</Descriptions.Item>
                            <Descriptions.Item label="设备位置">{data.POSITION_NAME}</Descriptions.Item>
                            <Descriptions.Item label="巡检人员">{data.Nav_ListUser?.map((item, i) => {
                                return <a style={{ color: item.ISCHECK == false ? "red" : "#000000A6" }}> {(i > 0 ? "，" : "") + item.Nav_User.NAME}</a>
                            })}</Descriptions.Item>
                            <Descriptions.Item label={"巡检人员签名"}>{
                                showUsersSign(listUserSign, config.picServerHost)
                            }
                            </Descriptions.Item>
                            <Descriptions.Item label="附件">{showFiles(data.Nav_Files, config.picServerHost)}</Descriptions.Item>
                        </Descriptions>
                    </div> : null
                }
                {
                    (data?.Nav_ListDetail && data?.Nav_ListDetail.length > 0) ?
                        <table className={styles.PrintFormLight}>
                            <tbody>
                                <tr className={styles.PrintFormLightTh}>
                                    <td>巡检部位</td>
                                    <td>巡检内容</td>
                                    <td>巡检标准</td>
                                    <td>巡检结论</td>
                                    <td>问题描述</td>
                                </tr>
                                {data?.Nav_ListDetail?.map((item, i) => {
                                    return <tr>
                                        <td>{item.ITEM1} </td>
                                        <td>{item.ITEM2} </td>
                                        <td>{item.ITEM3} </td>
                                        <td>{enums.CheckResult.enums[item.CHECK_VALUE]} </td>
                                        <td>{item.DESCRIPTION} </td>
                                    </tr>
                                })}
                            </tbody>
                        </table>
                        : null
                }
            </div>
        </div>
    }
}
export default connect(({ login, app }) => ({ login, app }))(DM032ShowPrint) 
